const state = {
    currencies: []
}

const getters = {
    getCurrencies(state) {
        return state.currencies
    },
    getRates(state) {
        return state.rates
    }
}

const mutations = {
    pushCurrencies(state, payload) {
        state.currencies = payload.currencies
    }
}

const actions = {
    fetchCurrencies({ commit }) {
        return new Promise((resolve, reject) => {
            let pos = new openerp.web.Model('eiru.pos')
            pos.call('get_currencies').then(response => {
                commit('pushCurrencies', {
                    currencies: response
                })

                console.log('fetched currencies')
                resolve()
            }).fail(error => {
                console.log(error);
                reject(error)
            })
        })
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
